package ordering;

/*
Copyright (C) 2015 Takuya KOUMURA
http://cycentum.miraiserver.com/intervalplayer/

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.

Attribution notices are included in the NOTICE file.
 */

import java.util.ArrayList;
import java.util.LinkedList;
import java.util.List;

import junit.framework.TestCase;

import org.apache.commons.math3.random.MersenneTwister;

public class Ordering
{
	public static ArrayList<Integer> order(MersenneTwister random, int numBlock, int numFile)
	{
		ArrayList<Integer> order=new ArrayList<>(numBlock*numFile);
		if(numFile==1)
		{
			for(int block=0; block<numBlock; ++block) order.add(0);
			return order;
		}
		addFirstBlock(random, order, numFile);
		ArrayList<ArrayList<Integer>> singleRemovedList=new ArrayList<>(numFile);
		for(int first=0; first<numFile; ++first)
		{
			ArrayList<Integer> list=new ArrayList<>(numFile-1);
			singleRemovedList.add(list);
			for(int file=0; file<numFile; ++file) if(file!=first) list.add(file);
		}
		for(int block=0; block<numBlock-1; ++block)
		{
			int first=singleRemovedList.get(order.get(order.size()-1)).get(random.nextInt(numFile-1));
			order.add(first);
			LinkedList<Integer> remaining=new LinkedList<>(singleRemovedList.get(first));
			for(int file=0; file<numFile-1; ++file)
			{
				int index=random.nextInt(remaining.size());
				order.add(remaining.remove(index));
			}
		}
		return order;
	}
	
	private static void addFirstBlock(MersenneTwister random, List<Integer> order, int numFile)
	{
		LinkedList<Integer> remaining=new LinkedList<>();
		for(int file=0; file<numFile; ++file) remaining.add(file);
		for(int file=0; file<numFile; ++file)
		{
			int index=random.nextInt(remaining.size());
			order.add(remaining.remove(index));
		}
	}
	
	public static class Test extends TestCase
	{
		public static void test()
		{
			MersenneTwister random=new MersenneTwister(4);
			int numFile=5, numBlock=1;
			ArrayList<Integer> order=order(random, numBlock, numFile);
			int i=0;
			for(int block=0; block<numBlock; ++block)
			{
				for(int f=0; f<numFile; ++f) System.out.print(order.get(i++)+" ");
				System.out.println();
			}
		}
	}
}
