package standardoutput;

/*
Copyright (C) 2015 Takuya KOUMURA
http://cycentum.miraiserver.com/intervalplayer/

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.

Attribution notices are included in the NOTICE file.
 */

import java.awt.Color;
import java.io.PrintStream;

import javax.swing.JOptionPane;
import javax.swing.JTextPane;
import javax.swing.text.BadLocationException;
import javax.swing.text.DefaultStyledDocument;
import javax.swing.text.SimpleAttributeSet;
import javax.swing.text.Style;
import javax.swing.text.StyleConstants;
import javax.swing.text.StyleContext;

public class StandardOutputTextPane extends StandardOutputDisplayer
{
	private JTextPane pane;
	private DefaultStyledDocument doc;
	private Style defaultStyle;
	private SimpleAttributeSet attributeRed;

	public StandardOutputTextPane()
	{
		pane=new JTextPane();
		pane.setEditable(false);
		
		StyleContext sc = new StyleContext();
		doc = new DefaultStyledDocument(sc);
		pane.setDocument(doc);
		defaultStyle=sc.getStyle(StyleContext.DEFAULT_STYLE);
		attributeRed=new SimpleAttributeSet();
		StyleConstants.setForeground(attributeRed, Color.RED);
	}

	public JTextPane textPane(){return pane;}
	
	@Override
	public void addOut(String string) throws BadLocationException
	{
		add(string, false);	
	}
	
	@Override
	public void addErr(String string) throws BadLocationException
	{
		add(string, true);	
	}
	
	
	public void add(String string, boolean red) throws BadLocationException
	{
		doc.insertString(doc.getLength(), string, red?attributeRed:defaultStyle);
		pane.setCaretPosition(doc.getLength());
	}
}
