package utils;

/*
Copyright (C) 2015 Takuya KOUMURA
http://cycentum.miraiserver.com/intervalplayer/

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.

Attribution notices are included in the NOTICE file.
 */

import java.util.Arrays;


public class Console
{
	private static void print(Object[] object, String deliminator, String suffix, boolean line)
	{
		for(Object o: object)
		{
			if(o instanceof boolean[]) System.out.print(Arrays.toString((boolean[])o));
			else if(o instanceof byte[]) System.out.print(Arrays.toString((byte[])o));
			else if(o instanceof int[]) System.out.print(Arrays.toString((int[])o));
			else if(o instanceof short[]) System.out.print(Arrays.toString((short[])o));
			else if(o instanceof float[]) System.out.print(Arrays.toString((float[])o));
			else if(o instanceof double[]) System.out.print(Arrays.toString((double[])o));
			else if(o instanceof long[]) System.out.print(Arrays.toString((long[])o));			
			else System.out.print(o);
			System.out.print(deliminator);
		}
		System.out.print(suffix);
		if(line) System.out.println();
	}
	
	public static void p(Object... obj){print(obj, " ", "", false);}
	public static void pl(Object... obj){print(obj, " ", "", true);}
	public static void psl(Object... obj){print(obj, " ", new Throwable().getStackTrace()[1].toString(), true);}
	public static void prl(Object... obj){print(obj, " ", "[Red]", true);}
	public static void pgl(Object... obj){print(obj, " ", "[Green]", true);}
	public static void pbl(Object... obj){print(obj, " ", "[Blue]", true);}
	public static void psrl(Object... obj){print(obj, " ", new Throwable().getStackTrace()[1].toString()+" [Red]", true);}
	public static void psgl(Object... obj){print(obj, " ", new Throwable().getStackTrace()[1].toString()+" [Green]", true);}
	public static void psbl(Object... obj){print(obj, " ", new Throwable().getStackTrace()[1].toString()+" [Blue]", true);}
	public static void pt(Object... obj){print(obj, "\t", "", false);}
	public static void ptl(Object... obj){print(obj, "\t", "", true);}
	public static void ptsl(Object... obj){print(obj, "\t", new Throwable().getStackTrace()[1].toString(), true);}
	public static void ptrl(Object... obj){print(obj, "\t", "[Red]", true);}
	public static void ptgl(Object... obj){print(obj, "\t", "[Green]", true);}
	public static void ptbl(Object... obj){print(obj, "\t", "[Blue]", true);}
	
}
